pcl::Filter< pcl::PCLPointCloud2 > Class Template Referenceabstract
Module filters

Filter represents the base filter class. More...

`#include <pcl/filters/filter.h>`

Inheritance diagram for pcl::Filter< pcl::PCLPointCloud2 >:

## Public Types

typedef boost::shared_ptr< Filter< pcl::PCLPointCloud2 > > | Ptr
typedef boost::shared_ptr< const Filter< pcl::PCLPointCloud2 > > | ConstPtr
typedef pcl::PCLPointCloud2 | PCLPointCloud2
typedef PCLPointCloud2::Ptr | PCLPointCloud2Ptr
typedef PCLPointCloud2::ConstPtr | PCLPointCloud2ConstPtr
Public Types inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
typedef pcl::PCLPointCloud2 | PCLPointCloud2
typedef boost::shared_ptr< PCLPointCloud2 > | PCLPointCloud2Ptr
typedef boost::shared_ptr< PCLPointCloud2 const > | PCLPointCloud2ConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| Filter (bool extract_removed_indices=false)
| Empty constructor. More...
virtual | ~Filter ()
| Empty destructor. More...
IndicesConstPtr const | getRemovedIndices ()
| Get the point indices being removed. More...
void | getRemovedIndices (PointIndices &pi)
| Get the point indices being removed. More...
void | filter (PCLPointCloud2 &output)
| Calls the filtering method and returns the filtered dataset in output. More...
Public Member Functions inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
| PCLBase ()
| Empty constructor. More...
virtual | ~PCLBase ()
| destructor. More...
void | setInputCloud (const PCLPointCloud2ConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PCLPointCloud2ConstPtr const | getInputCloud ()
| Get a pointer to the input point cloud dataset. More...
void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...

## Protected Member Functions

virtual void | applyFilter (PCLPointCloud2 &output)=0
| Abstract filter method. More...
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
Protected Member Functions inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
bool | initCompute ()
bool | deinitCompute ()

## Protected Attributes

IndicesPtr | removed_indices_
| Indices of the points that are removed. More...
bool | extract_removed_indices_
| Set to true if we want to return the indices of the removed points. More...
std::string | filter_name_
| The filter name. More...
Protected Attributes inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
PCLPointCloud2ConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...
std::vector< int > | field_sizes_
| The size of each individual field. More...
int | x_idx_
| The x-y-z fields indices. More...
int | y_idx_
int | z_idx_
std::string | x_field_name_
| The desired x-y-z field names. More...
std::string | y_field_name_
std::string | z_field_name_

## Detailed Description

### template<>
class pcl::Filter< pcl::PCLPointCloud2 >

Filter represents the base filter class.

All filters must inherit from this interface.

Author
  Radu B. Rusu

Definition at line 188 of file filter.h.

## Member Typedef Documentation

typedef boost::shared_ptr< const Filter<pcl::PCLPointCloud2> > pcl::Filter< pcl::PCLPointCloud2 >::ConstPtr

Definition at line 192 of file filter.h.

typedef pcl::PCLPointCloud2 pcl::Filter< pcl::PCLPointCloud2 >::PCLPointCloud2

Definition at line 194 of file filter.h.

typedef PCLPointCloud2::ConstPtr pcl::Filter< pcl::PCLPointCloud2 >::PCLPointCloud2ConstPtr

Definition at line 196 of file filter.h.

typedef PCLPointCloud2::Ptr pcl::Filter< pcl::PCLPointCloud2 >::PCLPointCloud2Ptr

Definition at line 195 of file filter.h.

typedef boost::shared_ptr< Filter<pcl::PCLPointCloud2> > pcl::Filter< pcl::PCLPointCloud2 >::Ptr

Definition at line 191 of file filter.h.

## Constructor & Destructor Documentation

pcl::Filter< pcl::PCLPointCloud2 >::Filter | ( | bool | extract_removed_indices = `false` | ) |

inline

Empty constructor.

Parameters

  [in] | extract_removed_indices | set to true if the filtered data indices should be saved in a separate list. Default: false.

Definition at line 202 of file filter.h.

virtual pcl::Filter< pcl::PCLPointCloud2 >::~Filter | ( |  | ) |

inline virtual

Empty destructor.

Definition at line 210 of file filter.h.

## Member Function Documentation

virtual void pcl::Filter< pcl::PCLPointCloud2 >::applyFilter | ( | PCLPointCloud2 & | output | ) |

protected pure virtual

Abstract filter method.

The implementation needs to set output.{data, row_step, point_step, width, height, is_dense}.

Parameters

  [out] | output | the resultant filtered point cloud

Implemented in pcl::VoxelGrid< pcl::PCLPointCloud2 >, pcl::PassThrough< pcl::PCLPointCloud2 >, pcl::CropBox< pcl::PCLPointCloud2 >, pcl::FilterIndices< pcl::PCLPointCloud2 >, pcl::StatisticalOutlierRemoval< pcl::PCLPointCloud2 >, pcl::ProjectInliers< pcl::PCLPointCloud2 >, pcl::RadiusOutlierRemoval< pcl::PCLPointCloud2 >, pcl::RandomSample< pcl::PCLPointCloud2 >, and pcl::ExtractIndices< pcl::PCLPointCloud2 >.

void pcl::Filter< pcl::PCLPointCloud2 >::filter | ( | PCLPointCloud2 & | output | ) |

Calls the filtering method and returns the filtered dataset in output.

Parameters

  [out] | output | the resultant filtered point cloud dataset

const std::string& pcl::Filter< pcl::PCLPointCloud2 >::getClassName | ( |  | ) | const

inline protected

Get a string representation of the name of this class.

Definition at line 256 of file filter.h.

IndicesConstPtr const pcl::Filter< pcl::PCLPointCloud2 >::getRemovedIndices | ( |  | ) |

inline

Get the point indices being removed.

Definition at line 214 of file filter.h.

References pcl::Filter< PointT >::removed_indices_.

void pcl::Filter< pcl::PCLPointCloud2 >::getRemovedIndices | ( | PointIndices & | pi | ) |

inline

Get the point indices being removed.

Parameters

  [out] | pi | the resultant point indices that have been removed

Definition at line 223 of file filter.h.

References pcl::Filter< PointT >::filter(), pcl::PointIndices::indices, and pcl::Filter< PointT >::removed_indices_.

## Member Data Documentation

bool pcl::Filter< pcl::PCLPointCloud2 >::extract_removed_indices_

protected

Set to true if we want to return the indices of the removed points.

Definition at line 240 of file filter.h.

std::string pcl::Filter< pcl::PCLPointCloud2 >::filter_name_

protected

The filter name.

Definition at line 243 of file filter.h.

IndicesPtr pcl::Filter< pcl::PCLPointCloud2 >::removed_indices_

protected

Indices of the points that are removed.

Definition at line 237 of file filter.h.

The documentation for this class was generated from the following file:

- /build/pcl-0nnAvv/pcl-1.7.2/filters/include/pcl/filters/filter.h